﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Game_Three
{
    public partial class Form1 : Form
    {
        public Random _random = new Random();
        public int NowFenShu = 0;
        public int TickTime = 20;

        public int RunTickTime = 0;
        public Form1()
        {
            InitializeComponent();
            BindData();
            button4.Text="暂停";
            button4.Enabled=false;
            button1.Enabled=false;

            timer1.Interval= 1000;
            timer1.Tick+=Timer1_Tick;


        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            RunTickTime--;
            if (RunTickTime<=0)
            {
                RunTickTime=0;
                timer1.Stop();
            }

            label3.Text = RunTickTime.ToString();
            if (RunTickTime==0)
            {
                MessageBox.Show("时间到-游戏结束 获得分数为 "+NowFenShu+" 分");
                FinishGame();
            }
        }

        public void BindData()
        {
            label2.Text=NowFenShu.ToString();
            label3.Text = TickTime.ToString();
        }

        public void Set_Buttons(bool onlyClear = false)
        {
            flowLayoutPanel1.Controls.Clear();
            RunTickTime = TickTime;
            label3.Text = RunTickTime.ToString();
            timer1.Stop();
            if (onlyClear==false)
            {
                timer1.Start();
                for (int i = 0; i < 50; i++)
                {
                    var next = _random.Next(100, 200);
                    Button btn = new Button();
                    btn.Width=50;
                    btn.Height=50;
                    btn.Click+=Btn_Click;
                    btn.Text=next.ToString();
                    btn.Tag= next;
                    flowLayoutPanel1.Controls.Add(btn);
                }
            }
        }

        private void Btn_Click(object sender, EventArgs e)
        {
            var btn = sender as Button;
            if (btn!=null)
            {
                if (int.TryParse(btn.Tag.ToString(), out int dat))
                {
                    if (dat%3==0)
                    {
                        NowFenShu++;
                        BindData();
                        Set_Buttons();
                    }
                    else
                    {
                        timer1.Stop();
                        MessageBox.Show("选择错误，游戏结束 获得分数为 "+NowFenShu+" 分");
                        FinishGame();
                    }

                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            button3.Enabled=false;
            button4.Enabled=true;
            button1.Enabled=true;

            Set_Buttons();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FinishGame();
        }

        private void FinishGame()
        {
            button3.Enabled=true;
            button4.Enabled=false;
            button1.Enabled=false;
            button4.Text="暂停";
            NowFenShu=0;
            Set_Buttons(true);
            BindData();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (button4.Text=="暂停")
            {
                button4.Text="恢复";
                timer1.Stop();
            }
            else
            {
                timer1.Start();
                button4.Text="暂停";
            }

        }
    }
}
